varying highp vec2 v_texCoord;
varying highp vec2 v_texCoordRounded;

uniform highp sampler2D u_texture;  // Template (for R)
uniform highp sampler2D u_texture1; // Template (for GB)
uniform highp sampler2D u_texture2; // Palette

uniform highp vec4 u_colorableImageSize;

void main() {
	mediump float gray = texture2D(u_texture, v_texCoord).r;
	highp vec2 paletteCoord = texture2D(u_texture1, v_texCoord).bg;

	// This if/else could be simplified (the two final lines could be extracted and the else removed)
	// but doing so creates bugs in mobile in some specific images
	if (paletteCoord == vec2(0.0, 0.0))
	{
		highp vec2 nextTexel = 1.0 / u_colorableImageSize.xy;
		highp vec2 otherSamples[8];
		otherSamples[0] = vec2(nextTexel.x, 0.0);
		otherSamples[1] = vec2(-nextTexel.x, 0.0);
		otherSamples[2] = vec2(0.0, nextTexel.y);
		otherSamples[3] = vec2(0.0, -nextTexel.y);
		otherSamples[4] = vec2(nextTexel.x, nextTexel.y);
		otherSamples[5] = vec2(-nextTexel.x, -nextTexel.y);
		otherSamples[6] = vec2(nextTexel.x, -nextTexel.y);
		otherSamples[7] = vec2(-nextTexel.x, nextTexel.y);

		for (int i = 0; i < 8 && paletteCoord == vec2(0.0, 0.0); i++)
		{
			paletteCoord = texture2D(u_texture1, v_texCoord + otherSamples[i]).bg;
		}

		mediump vec3 colorInfo = texture2D(u_texture2, paletteCoord).rgb;
		gl_FragColor = vec4(colorInfo * gray, 1.0);
	}
	else
	{
		mediump vec3 colorInfo = texture2D(u_texture2, paletteCoord).rgb;
		gl_FragColor = vec4(colorInfo * gray, 1.0);
	}
	
}

