buttonColor1 = API_ToHash("color_btn1")
buttonColor2 = API_ToHash("color_btn2")
buttonColor3 = API_ToHash("color_btn3")
buttonColor4 = API_ToHash("color_btn4")
buttonColor5 = API_ToHash("color_btn5")
buttonColor6 = API_ToHash("color_btn6")
buttonColor7 = API_ToHash("color_btn7")
buttonColor8 = API_ToHash("color_btn8")
buttonColor9 = API_ToHash("color_btn9")
buttonColor10 = API_ToHash("color_btn10")
buttonColor11 = API_ToHash("color_btn11")
buttonColor12 = API_ToHash("color_btn12")
buttonPostcard = "postcard_area_174"

numAreasColored = 0

zoomInTriggerFactor = 0.2

local postcardWithColoringTutorial = "postcard_1"
local isColoringTutorialInProcess = false
local isZoomTutorialInProgress = false

function OnColoringStarted(postcardId)
	--API_SetTutorialAsTriggered("tutorial_coloring", "false")
	local isColoringTutorialCompleted = API_HasTutorialBeenTriggered("tutorial_postcard_coloring") == "true"
	if not isColoringTutorialCompleted and postcardId == postcardWithColoringTutorial then
		StartColoringTutorialWithDelay(2)
	end

	playerAlreadyZoomed = API_HasTutorialBeenTriggered("tutorial_postcard_zoom") == "true"
end

function OnButtonPressed(buttonName)
	if isColoringTutorialInProcess then
		if buttonName == buttonColor1 
		or buttonName == buttonColor2 
		or buttonName == buttonColor3 
		or buttonName == buttonColor4 
		or buttonName == buttonColor5 
		or buttonName == buttonColor6 
		or buttonName == buttonColor7 
		or buttonName == buttonColor8 
		or buttonName == buttonColor9 
		or buttonName == buttonColor10 
		or buttonName == buttonColor11 
		or buttonName == buttonColor12 
		then
			OnColorSelected()
		end
	end

	if buttonName == "btn_play_on" then
		if isZoomTutorialInProgress then
			ZoomTutorialContinue()
		end
	end
end

function OnPostcardAreaColored(areaName, isColoredWithSameColor, fractionColored)
	if isColoringTutorialInProcess and tonumber(isColoredWithSameColor) == 0 then
		OnCanvasPainted()
	end

	--API_SetTutorialAsTriggered("tutorial_postcard_completed", "false")
	if API_HasTutorialBeenTriggered("tutorial_postcard_completed") == "false" then
		if tonumber(fractionColored) >= 1.0 then
			StartPostcardCompletedTutorial()
			API_SetTutorialAsTriggered("tutorial_postcard_completed", "true")
		end
	end

	if tonumber(isColoredWithSameColor) == 0 then
		numAreasColored = numAreasColored + 1
	end

	--API_SetTutorialAsTriggered("tutorial_postcard_zoom", "false")
	if not isZoomTutorialInProgress and not playerAlreadyZoomed then
		if numAreasColored >= 11 then
			StartZoomTutorial()
		end
	end
end

function OnZoomChanged(zoomScale)
	if not isZoomTutorialInProgress then
		if not playerAlreadyZoomed then
			API_SetTutorialAsTriggered("tutorial_postcard_zoom", "true")
			playerAlreadyZoomed = true
		end
	else
		zoomScale = tonumber(zoomScale)
		if (zoomScale > zoomInTriggerFactor) then
			if (zoomedIn == false) then
				zoomedIn = true
				OnZoomTutorialFinished()
			end
		end
	end
end


-- Coloring tutorial

function StartColoringTutorialWithDelay(delaySeconds)
	isColoringTutorialInProcess = true
	API_SetInputAllowed("false")
	API_CallFunctionAfterDelay("StartColoringTutorial", "", delaySeconds)
end
function StartColoringTutorial()
	API_ShowDarkOverlay("false")
	API_SetInputAllowed("false")
	API_AllowInputOn("color")
	API_ShowImageAtComponent("hand_touch_v2_sml", "color_btn3", "0.5", "0.3", "false", "true", "")
	API_SetElementsVisibility("UndoButton", "false")
	API_SetElementsVisibility("ShareButton", "false")
	API_SetElementsVisibility("palette_arrow_rt", "false")
	API_SetScrollingEnabledByClass("palette_scroller", "false")
end

function OnColorSelected()
	API_HideDarkOverlay()
	API_SendToBack("color")
	API_HideAllImages()
	API_SetInputAllowed("false")
	for areaIndex=0,200 do
		API_AllowInputOn("postcard_area_"..areaIndex)
	end
	API_ShowImageAtComponent("hand_touch_v2_sml", "viewport_container", "0.5", "0.55", "false", "false", "tut_how_to_color_hand")
end

function OnCanvasPainted()
	API_SetTutorialAsTriggered("tutorial_postcard_coloring", "true")
	API_HideAllImages()
	API_CallFunctionAfterDelay("ShowColoringFinalHint", "", "0.25")
end

function ShowColoringFinalHint()
	isColoringTutorialInProcess = false
	API_ShowPopup("tooltip_center", "center", "tut_coloring_popup_title", "tut_coloring_popup_body", "", "")
	API_CallFunctionAfterDelay("OnColoringFinalHintFinished", "", "4")
	API_SetScrollingEnabledByClass("palette_scroller", "true")
end

function OnColoringFinalHintFinished()
	API_SetInputAllowed("true")
	API_HidePopup()
	API_SetElementsVisibility("UndoButton", "true")
	API_SetElementsVisibility("ShareButton", "true")
	API_SetElementsVisibility("palette_arrow_rt", "true")
end


-- Postcard completed tutorial

function StartPostcardCompletedTutorial()
	API_SetInputAllowed("false")
	API_ShowPopup("tooltip_center", "center", "tut_postcard_completed_title", "tut_postcard_completed_body", "", "")
	API_CallFunctionAfterDelay("HidePopup", "", "4")
end
function HidePopup()
	API_SetInputAllowed("true")
	API_HidePopup()
end


-- Zoom tutorial

function StartZoomTutorial()
	isZoomTutorialInProgress = true
	zoomedIn = false
	API_ShowDarkOverlay("true")
	API_ShowPopup("with_button", "center", "Tut_5_zoom_title", "tut_5_zoom_body", "tut_5_zoom_button", "")
	API_SetInputAllowed("false")
end

function ZoomTutorialContinue()
	API_HidePopup()
	API_HideDarkOverlay()
	API_SetInputAllowed("false")
	API_AllowInputOn("viewport_container")
	API_AllowInputOn("album_btn")
	API_ShowImageAtComponent("hand_pinch_v2_spine_sml", "viewport_container", "0.5", "0.4", "false", "false", "Tut_5_zoom_in_title")
end

function OnZoomTutorialFinished()
	API_SetInputAllowed("true")
	API_HideAllImages()
	API_SetTutorialAsTriggered("tutorial_postcard_zoom", "true")
	isZoomTutorialInProgress = false
	playerAlreadyZoomed = true
end
